# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from abb_egm_msgs/EGMState.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import abb_egm_msgs.msg
import std_msgs.msg

class EGMState(genpy.Message):
  _md5sum = "a239c0f02980c16cd34f9e56fbc03ff7"
  _type = "abb_egm_msgs/EGMState"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """#-------------------------------------------------------------------------------
# Description:
#   The purpose of this message definition, is to represent a subset of states
#   of all (known) EGM communication channels.
#-------------------------------------------------------------------------------

#-------------------------------------------------------------------------------
# Message fields
#-------------------------------------------------------------------------------
# Metadata.
std_msgs/Header header

# EGM channel states.
EGMChannelState[] egm_channels

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: abb_egm_msgs/EGMChannelState
#-------------------------------------------------------------------------------
# Description:
#   The purpose of this message definition, is to represent a subset of states
#   of an EGM communication channel. I.e. a channel between an EGM client,
#   in an ABB robot controller system, and an external EGM server.
#-------------------------------------------------------------------------------

#-------------------------------------------------------------------------------
# Enumerations
#-------------------------------------------------------------------------------
# EGM client states:
uint8 EGM_UNDEFINED = 1
uint8 EGM_ERROR     = 2
uint8 EGM_STOPPED   = 3
uint8 EGM_RUNNING   = 4

# Motor states:
uint8 MOTORS_UNDEFINED = 1
uint8 MOTORS_ON        = 2
uint8 MOTORS_OFF       = 3

# RAPID states:
uint8 RAPID_UNDEFINED = 1
uint8 RAPID_STOPPED   = 2
uint8 RAPID_RUNNING   = 3

#-------------------------------------------------------------------------------
# Message fields
#-------------------------------------------------------------------------------
# The EGM channel's name.
string name

# The EGM channel's active/inactive status.
bool active

# Indicator for if the EGM convergence criteria is currently fulfilled or not.
bool egm_convergence_met

# EGM client state.
uint8 egm_client_state

# Motor state.
uint8 motor_state

# RAPID execution state.
uint8 rapid_execution_state

# Utilization rate of the connected mechanical unit.
#
# An utilization rate > 100 mean that EGM motion references are
# too aggressive and should be reduced.
float64 utilization_rate
"""
  __slots__ = ['header','egm_channels']
  _slot_types = ['std_msgs/Header','abb_egm_msgs/EGMChannelState[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,egm_channels

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(EGMState, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.egm_channels is None:
        self.egm_channels = []
    else:
      self.header = std_msgs.msg.Header()
      self.egm_channels = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.egm_channels)
      buff.write(_struct_I.pack(length))
      for val1 in self.egm_channels:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_5Bd().pack(_x.active, _x.egm_convergence_met, _x.egm_client_state, _x.motor_state, _x.rapid_execution_state, _x.utilization_rate))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.egm_channels is None:
        self.egm_channels = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.egm_channels = []
      for i in range(0, length):
        val1 = abb_egm_msgs.msg.EGMChannelState()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 13
        (_x.active, _x.egm_convergence_met, _x.egm_client_state, _x.motor_state, _x.rapid_execution_state, _x.utilization_rate,) = _get_struct_5Bd().unpack(str[start:end])
        val1.active = bool(val1.active)
        val1.egm_convergence_met = bool(val1.egm_convergence_met)
        self.egm_channels.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.egm_channels)
      buff.write(_struct_I.pack(length))
      for val1 in self.egm_channels:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_5Bd().pack(_x.active, _x.egm_convergence_met, _x.egm_client_state, _x.motor_state, _x.rapid_execution_state, _x.utilization_rate))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.egm_channels is None:
        self.egm_channels = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.egm_channels = []
      for i in range(0, length):
        val1 = abb_egm_msgs.msg.EGMChannelState()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 13
        (_x.active, _x.egm_convergence_met, _x.egm_client_state, _x.motor_state, _x.rapid_execution_state, _x.utilization_rate,) = _get_struct_5Bd().unpack(str[start:end])
        val1.active = bool(val1.active)
        val1.egm_convergence_met = bool(val1.egm_convergence_met)
        self.egm_channels.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_5Bd = None
def _get_struct_5Bd():
    global _struct_5Bd
    if _struct_5Bd is None:
        _struct_5Bd = struct.Struct("<5Bd")
    return _struct_5Bd
